var Controller = function() {
	var _numbers = { 48:0, 49:1, 50:2, 51:3, 52:4, 53:5, 54:6, 55:7, 56:8, 57:9 }
	var _KEY_ENTER = -1
	var _KEY_LEFT = -2
	var _KEY_UP = -3
	var _KEY_RIGHT = -4
	var _KEY_DOWN = -5
	var _KEY_DELETE = -6
	var _KEY_NUMBER = -7
	
	var _key = null
	var _dateKey = null
	var _longEnterFired = false
	
	var _objectsOnResize = []
	
	var _keys = {
		63557:_KEY_ENTER, 13:_KEY_ENTER, 0:_KEY_ENTER, // enter
		63495:_KEY_LEFT, 37:_KEY_LEFT, // left
		63497:_KEY_UP, 38:_KEY_UP, // up
		63496:_KEY_RIGHT, 39:_KEY_RIGHT, // right
		63498:_KEY_DOWN, 40:_KEY_DOWN, // down
		8:_KEY_DELETE, // delete
		// numbers
		48:_KEY_NUMBER, 49:_KEY_NUMBER, 50:_KEY_NUMBER,
		51:_KEY_NUMBER, 52:_KEY_NUMBER, 53:_KEY_NUMBER,
		54:_KEY_NUMBER, 55:_KEY_NUMBER, 56:_KEY_NUMBER,
		57:_KEY_NUMBER
	}
	
	
	function _getControl() {		
		var control = View.getCurrent()
		if (View.isLandscape() && typeof Landscape !== "undefined") {
			control = Landscape
		} else if (typeof Loading !== "undefined" && Loading.isRunning()) {
			control = Loading
		}		
		return control
	}
	
	function _isLongKey() {
		var r = false
		if (this.dateKey != null) {
			var date = new Date();
			var time = date.getTime() - this.dateKey.getTime();
			r = (time > Config.longKeyTime);
		}
		return r;
	}
	
	function _stopEvent(event) {		
		event.preventDefault()
		event.stopPropagation()
	}
	
	function _getKeyCode(event) {
		var keyCode = event.keyCode == 0 ? event.charCode : event.keyCode
	}
	
	function _getNumber(event) {
		return _numbers[_getKeyCode(event)]
	}
	
	function _getKey(event) {
		return _keys[_getKeyCode(event)]
	}
	
	// INIT
	return {
		init: function() {
			
		},
		onResize: function(event) {
			for (var i = 0, o; o = _objectsOnResize[i]; i++) {
				if (Object.isFunction(o.onResize)) {
					o.onResize(event)
				}
			}
		},
		registerOnResize: function(o) {
			_objectsOnResize.push(o)
		},
		keyDown: function(event) {
			_key = _getKey(event)
			if (_key == _KEY_ENTER) {
				_dateKey = new Date()
			} else {
				_dateKey = null
			}
			
			var control = _getControl()			
			if (control.preventEvent) {
				_stopEvent(event)
			}
			
		},
		keyUp: function(event) {
			if (Terminal.isV360()) {
				if (!_longEnterFired && _key == _KEY_ENTER) {
					var control = _getControl()
					
					if (control.preventEvent) {
						_stopEvent(event)
					}
					
					control.onEnter()
				} else {
					_longEnterFired = false
				}
				_key = null
				_dateKey = null
			}
		},
		keyPress: function(event) {		
			var control = _getControl()
			
			if (control.preventEvent) {
				_stopEvent(event)
			}
			
			if (control.onAnyKey) {
				control.onAnyKey(event)
			} else {
				switch (_key) {
					case _KEY_ENTER:
						if (Terminal.isOVI()) {
							control.onEnter()
						} else if (!_longEnterFired && _isLongKey()) {
							control.onLongEnter(event)
							_longEnterFired = true
						}
						break
					case _KEY_LEFT:
						control.onLeft(event)
						break
					case _KEY_UP:
						control.onUp(event)
						break
					case _KEY_RIGHT:
						control.onRight(event)
						break
					case _KEY_DOWN:
						control.onDown(event)
						break
					case _KEY_DELETE:
						control.onDelete(event)
						break
					case _KEY_NUMBER:
						control.onNumber(_getNumber(event),event)
						break;
					default:
						if (control.onOtherKey) {
							control.onOtherKey(event)
						}
				}
			}
		},
		close: function() {
			if (typeof Application != "undefined" && Application.onClose) {
				Application.onClose()
			}
			window.close()
		}
	}
}()