
var BGRotator = function(el, numFrames, url, speed) {
    var _el = el
    var _numFrames = numFrames
    var _speed = speed || 100
    var _current = 0
    var _running = false
	
	var _height = 0
	var _width = 0
    var _onStop = null
    var _intervalId = null
    var _timeoutId = null

	
    function _setFrame() {
		_el.style.backgroundPosition = "0px " + -(_current * _height) + "px"
    }
	
    function _setNextFrame() {
        _current = (_current + 1) % numFrames
        _setFrame()
    }
	
	var imgPreload = new Image()
	imgPreload.onload = function() {
		_width = this.width
		_height = parseInt(this.height / numFrames)
		el.width = this.width
		el.height = this.height
		_el.style.backgroundImage = "url("+url+")"
		_setFrame()
	}
	imgPreload.src = url
		
	return {
	    start: function(time,onStop) {			
	        this.stop()
	        _running = true	        
			var self = this
	        if (time !== undefined) {				
	            _timeoutId = setTimeout(function() {
	                self.stop()
	            },time)
	        }			
	        if (onStop !== undefined) {
	            _onStop = onStop
	        }

	        _intervalId = setInterval(function() {
	            _setNextFrame()
				
	        },_speed)
	    },
	    stop: function() {
	        _running = false
	        if (_intervalId) {
				clearInterval(_intervalId)
				_intervalId = null
			}
			if (_timeoutId) {
				clearTimeout(_timeoutId)
				_timeoutId = null
			}
	        if (_onStop) {
	            _onStop()
				_onStop = null
	        }
	    },
	    isRunning: function() {
	        return _running
	    }
	}	
}