var Console = function() {
    var _console = document.createElement('div')
	_console.setAttribute("id","console")
	
	function _printException(e) {
		var text = ""
		// WIDGET OPERA EMULATOR
		if (parent.emulator) {
			var line = e["opera#sourceloc"]
			var file = ""
			if (e.stacktrace) {
				file = e.stacktrace.split("/sandbox/")[1].split(".js")[0]+".js"
			}
			text = "EXCEPTION ("+file+":"+line+"): "
			
		// NOKIA WRT
		} else if (e.lineNumber || e.line) {
			var file = e.fileName || e.sourceURL
			if (file) {
				var a = file.split("/")
				file = a[a.length-1]
			}
			var line = e.lineNumber || e.line
			
			text = "EXCEPTION ("+file+":"+line+"): "
			
		// VODAFONE APPS MANAGER
		} else if (e.sourceURL === undefined) {
			text = "EXCEPTION: "				
		} else {
			var file = e.sourceURL.split("js/")[1];
			text = "EXCEPTION ("+file+":"+line+"): "
		}
		
		return text
	}
	
	return {
		init: function() {
			var cs = _console.style
			cs.position = "absolute"
			cs.top = "0px"
			cs.left = "0px"
			cs.zIndex = "100"
			cs.backgroundColor = "black"
			cs.color = "white"
			cs.opacity = "0.7"
			cs.width = "100%"
			cs.fontSize = "12px"
			
			View.getBody().appendChild(_console)
			
			var self = this
			_console.addEventListener('mousedown', function(){
				self.clear()
			}, false)
		},
		pBody: function() {
			if (Config.debug) {
				var body = document.getElementsByTagName("body")[0]
				for (var i = 0, l = arguments.length; i < l; i++) {
					body.insert(arguments[i] + "<br/>")
				}
			}
		},
		eBody: function(e) {
			var text = _printException(e)
			this.pBody(text,e.message)
		},
		e: function(e) {
			var text = _printException(e)
			this.p(text,e.message)
		},
		pArray: function(a) {
			var t = a[0] ? "["+a[0] : "["
			for (var i = 1; i < a.length; i++) {
				t += "," + a[i]
			}			
			this.p(t+"]")
		},
		post: function() {
			if (Config.debug) {
				// OPERA CONSOLE
				if (!Config.console && View.isEmulator() && parent.opera && opera.postError) {
					var t = "";
					for (var i = 0, l = arguments.length; i < l; i++) {
						t += arguments[i] + "\n"
					}
					opera.postError(t)
				// OVI FIREFOX CONSOLE
				} else if (!Config.console && typeof console !== "undefined" && typeof netscape !== "undefined") {
					for (var i = 0, l = arguments.length; i < l; i++) {
						console.log(arguments[i])
					}
				// DIV CONSOLE
				} else {
					for (var i = 0, l = arguments.length; i < l; i++) {
						_console.appendChild(document.createTextNode(arguments[i]))
						_console.appendChild(document.createElement('hr'))
					}
				}
			}
		},
		p: function() {
			if (Config.debug) {
				// OPERA CONSOLE
				if (!Config.console && View.isEmulator() && parent.opera && opera.postError) {
					var t = "";
					for (var i = 0, l = arguments.length; i < l; i++) {
						t += arguments[i] + "\n"
					}
					opera.postError(t)
				// OVI FIREFOX CONSOLE
				} else if (!Config.console && typeof console !== "undefined" && typeof netscape !== "undefined") {
					for (var i = 0, l = arguments.length; i < l; i++) {
						console.log(arguments[i])
					}
				// DIV CONSOLE
				} else {
					for (var i = 0, l = arguments.length; i < l; i++) {
						_console.appendChild(document.createTextNode(arguments[i]))
						_console.appendChild(document.createElement('hr'))
					}
				}
			}
		},
		clear: function() {
			while (_console.hasChildNodes()) {
				_console.removeChild(_console.firstChild)
			}
		},
		show: function() {
			_console.style.display = "block"
		},
		hide: function() {
			_console.style.display = "none"
		}
	}
}()