var GGG = {}

GGG.Config = {
	userService: "revistasAPI",
	passService: "rvstsAPI_392634932",
	appVersion: "0001",
	
	userIdURL: "http://revistas.noibox.com/iphone/users/newuser.aspx",
	sessionURL: "http://revistas.noibox.com/iphoneWSForm/SessionProvider.aspx",
	adserverURL: "http://adserver.noibox.com/v06/adserver_widget.asp",
	statsURL: "http://revistas.noibox.com/api/stats/listener.aspx",
	
	closeBtnPath: "img/close.png",
	USER_ID_KEY: "userId",
	reloadAdDefault: 8, // seconds
	adTimeVisibleDefault: 6, // seconds
	adTimeoutTime: 4, // seconds
	adTypes: "1100", // banner, interstitial, half-screen, text
	supportsLandscape: true
}

GGG.Initialize = function(appId, console, onInitFinished) {
	GGG.Console.init(console)
	if (GGG.Utils.isDefined(appId)) {
		GGG.UserId.init(appId, function(userId) {
			GGG.AdServer.init(userId)
			
			GGG.Stats.init(userId, appId)
			if (GGG.Utils.isFunction(onInitFinished)) {
				onInitFinished()
			}
		})
	} else if (!GGG.Utils.isDefined(appId)) {
		GGG.Console.p("INIT: appId is undefined")
	} else if (!GGG.Utils.isDefined(appPassword)) {
		GGG.Console.p("INIT: appPassword is undefined")
	}
}

GGG.UserId = function() {
	var _userIdURL = ""
	var _userId = ""
	var _appId = ""
	
	var _USER_ID_KEY = ""
	
	function _loadUserId(onUserIdLoaded) {
        _userId = GGG.Preference.load(_USER_ID_KEY)
		
        if (_userId === GGG.Preference.EMPTY) {
			
			GGG.Ajax.send(_userIdURL, GGG.Ajax.POST, function(xhr) {
				GGG.Console.p("USER ID SUCCESS: " + xhr.responseText)
				_userId = xhr.responseText
				GGG.Preference.save(_USER_ID_KEY, _userId)
				if (GGG.Utils.isFunction(onUserIdLoaded)) {
					onUserIdLoaded(_userId)
				}
			}, function(xhr, e) {
				GGG.Console.p("USER ID LOAD ERROR")
				if (GGG.Utils.isDefined(e)) {
					GGG.Console.e(e)
				}
			})
			
		} else {
			GGG.Console.p("USER ID PREFERENCE LOADED: " + _userId)
			if (GGG.Utils.isFunction(onUserIdLoaded)) {
				onUserIdLoaded(_userId)
			}
		}
	}
		
	return {
		init: function(appId, onUserIdLoaded) {
			_USER_ID_KEY = GGG.Config.USER_ID_KEY
			if (GGG.Utils.isDefined(appId)) {
				_appId = appId
				
				_userIdURL = GGG.Config.userIdURL 
				_userIdURL += "?u=" + GGG.Config.userService
				_userIdURL += "&p=" + GGG.Config.passService
				_userIdURL += "&id=" + _appId
				
				_loadUserId(onUserIdLoaded)
			}
		},
		getUserId: function() {
			return _userId
		},
		removeUserId: function() {
			GGG.Preference.remove(_USER_ID_KEY)
		}
	}
}()

GGG.Session = function() {
	var _appId = ""
	var _appPassword = ""
	var _userId = ""
	var _session = {}
	var _sessionLoadedListeners = []
	
	function _fireSessionEvent() {
		for (var i = 0, o; o = _sessionLoadedListeners[i]; i++) {
			if (GGG.Utils.isFunction(o.onSessionLoaded)) {
				o.onSessionLoaded(_session)
			} else if (GGG.Utils.isFunction(o)) {
				o(_session)
			}
		}
	}
	
	function _loadSession() {
		var url = GGG.Config.sessionURL 
		url += "?u=" + GGG.Config.userService
		url += "&p=" + GGG.Config.passService
		url += "&idApp=" + _appId
		url += "&idCliente=" + _userId
		url += "&password=" + _appPassword
		
		GGG.Ajax.send(url, GGG.Ajax.POST, function(xhr) {
			GGG.Console.p("SESSION LOADED: " + xhr.responseText)
                var session = xhr.responseText.split("#|*")
				
                _session.id = session[0]
                _session.expireTime = parseInt(session[1], 10)
                _session.adServerTime = parseInt(session[2], 10)
				
				_fireSessionEvent()
				
                // reload session
				if (_session.expireTime > 0) {
	                setTimeout(function() {
	                    _loadSession()
	                },(_session.expireTime/2)*1000)
				}
					
		}, function(xhr, e) {
			GGG.Console.p("SESSION ERROR")
			if (GGG.Utils.isDefined(e)) {
				GGG.Console.e(e)
			}
		})
	}
	
	return {
		init: function(appId, appPassword, userId) {
			_appId = appId
			_appPassword = appPassword
			_userId = userId
			_loadSession()
		},
		registerOnSessionLoaded: function(o) {
			GGG.Console.p("REGISTER SESSION LOADED: " + o)
			if (GGG.Utils.isDefined(o)) {
				_sessionLoadedListeners.push(o)
			}
		},
		getSessionId: function() {
			return _session.id
		}
	}
}()

GGG.Stats = function() {
	var _statsURL = ""
	var _userId = null
	var _appId = null
	var _deviceType = null
	
	var _DEVICE_V360 = "v360"
	var _DEVICE_OVI = "ovi"
		
	return {
		init: function(userId, appId) {
			_userId = userId
			_appId = appId
			_deviceType = GGG.Utils.isOVI() ? _DEVICE_OVI : _DEVICE_V360
			_statsURL = GGG.Config.statsURL
            _statsURL += "?uId=" + _userId
			_statsURL += "&aid=" + _appId
			_statsURL += "&dt=" + _deviceType
		},
		send: function(statId, param) {
			if (GGG.Utils.isDefined(statId) && _userId) {
	            var url = _statsURL
	            url += "&sId=" + statId
				if (GGG.Utils.isDefined(param)) {
                	url += "&cId=" + param
				}
				GGG.Console.p ("-> "+url)
				GGG.Ajax.send(url, GGG.Ajax.GET, function(xhr) {
					GGG.Console.p("STATS SEND (" + statId + "): " + xhr.responseText)
				}, function(xhr, e) {
					GGG.Console.p("STATS SEND ERROR: " + url)
					if (GGG.Utils.isDefined(e)) {
						GGG.Console.e(e)
					}
				})
				
			} else {
				GGG.Console.p("STATS not initialized")
			}
		}
	}
}()

GGG.AdServer = function() {
	var _TYPE_BANNER = "1"
	var _TYPE_INTERSTITIAL = "2"
	var _TYPE_HALF_SCREEN = "3"
	
	var _renderType = "json"
	var _firstAd = true
	var _running = true
	
	var _adServerURL = null
	var _ad = null
	
	var _reloadAdTime = null
	var _adTimeVisible = null
	var _nextAdTimeoutId = null
	var _adHideTimeoutId = null
	var _closeBtn = null
	var _adDivPortrait = null
	var _adDivLand = null
	var _adDivPortraitHeight = 0
	var _adDivLandHeight = 0
	
	// close btn functions
	function _clickCloseBtn() {
		_hideCloseBtn()
		_removeAd()
	}
	function _hideCloseBtn() {
		_closeBtn.style.display = "none"
	}
	function _showCloseBtn() {
		_closeBtn.style.display = "block"
	}
	// ad functions
	function _adClick() {
		_hideCloseBtn()
		_removeAd()
		GGG.Utils.openURL(_ad.link.href)
	}
	function _hideAd() {
		_hideCloseBtn()
		var adDiv = GGG.Utils.isPortrait() ? _adDivPortrait : _adDivLand
		GGG.Animation.disappearBottom(adDiv, function() {
			_removeAd()
		})
	}
	function _removeAd() {
		_adDivPortrait.style.display = "none"
		_adDivLand.style.display = "none"
		clearTimeout(_adHideTimeoutId)
		GGG.Utils.removeChilds(_adDivPortrait)
		GGG.Utils.removeChilds(_adDivLand)
		_setNextTimeout()
	}
	function _setAdDivStyle(adDiv) {
		adDiv.style.position = "fixed"
		adDiv.style.top = "0px"
		adDiv.style.left = "0px"
		adDiv.style.width = "100%"
		adDiv.style.overflow = "hidden"
		adDiv.style.backgroundPosition = "center"
		adDiv.style.backgroundRepeat = "no-repeat"
		adDiv.style.zIndex = "1000"
		adDiv.style.display = "none"
		
		adDiv.addEventListener('click', _adClick, false)
		
		GGG.Utils.getBody().appendChild(adDiv)
	}
	
	// checker functions
	function _allowed() {
		return !GGG.Utils.isDocked() && !GGG.Utils.isFloating() && !GGG.Utils.isHomeScreen()
	}
	function _firstAdReady() {
		return _firstAd && GGG.Utils.isDefined(_tag)
	}
	
	// DRAW AD
	function _drawAd() {
		
		// portrait
		var imgPortrait = GGG.Utils.img()
		imgPortrait.onload = function() {
			GGG.Console.p("ADSERVER: IMAGE PORTRAIT LOADED")
			_setHideTimeout()
			var onEnd = null
			if (_ad.type === _TYPE_INTERSTITIAL) {
				_adDivPortrait.style.top = "0px"
				onEnd = function() {
					_showCloseBtn()
				}
			} else {
				_adDivPortrait.style.top = (GGG.Utils.getHeight() - this.height) + "px"
			}
			
			_adDivPortrait.appendChild(this)
			_adDivPortraitHeight = this.height
		
			if (_allowed() && GGG.Utils.isPortrait() && _running) {
				GGG.Animation.appearBottom(_adDivPortrait, this.height, onEnd)
			}
		}
		imgPortrait.onerror = function() {
			GGG.Console.p("ADSERVER: PORTRAIT IMAGE FAILED")
			_setNextTimeout()
		}
		imgPortrait.src = _ad.banner.src
		
		// landscape
		var imgLand = GGG.Utils.img()
		imgLand.onload = function() {
			GGG.Console.p("ADSERVER: IMAGE LANDSCAPE LOADED")
			_setHideTimeout()
			
			var onEnd = null
			if (_ad.type === _TYPE_INTERSTITIAL) {
				_adDivLand.style.top = "0px"
				onEnd = function() {
					_showCloseBtn()
				}
			} else {
				_adDivLand.style.top = (GGG.Utils.getHeight() - this.height) + "px"
			}
			
			_adDivLand.appendChild(this)
			_adDivLandHeight = this.height
			
			if (_allowed() && GGG.Utils.isLandscape()) {
				GGG.Animation.appearBottom(_adDivLand, this.height, onEnd)
			}
		}
		imgLand.onerror = function() {
			GGG.Console.p("ADSERVER: LANDSCAPE IMAGE FAILED")
			_setNextTimeout()
		}
		imgLand.src = _ad.bannerLand.src
		
		// preload timeout
		setTimeout(function() {
			if (GGG.Utils.isPortrait() && !imgPortrait.complete) {
				GGG.Console.p("ADSERVER: Portrait image INcomplete")
				_setNextTimeout()
			} else if (GGG.Utils.isLandscape() && !imgLand.complete) {
				GGG.Console.p("ADSERVER: Landscape image INcomplete")
				_setNextTimeout()	
			}
		},_adTimeoutTime)
	}
	
	// LOAD AD
	function _loadAd() {
		if (_running) {
			var url = _adServerURL
			url += "&t=" + _tag
			url += "&w=" + GGG.Utils.getPortraitWidth()
			url += "&h=" + GGG.Utils.getPortraitHeight()
			
			GGG.Ajax.send(url, GGG.Ajax.GET, function(xhr) {
				_fetchingBanner = true
				GGG.Console.p("ADSERVER: AD LOADED")
				var json = xhr.responseText
				if (json == "") {
					GGG.Console.p("ADSERVER: empty json")
					_setNextTimeout()
				} else {
					var ads = eval("("+ json +")")
					
					if (ads && ads.ads && ads.ads.ad && ads.ads.ad.transId && ads.ads.ad.transId != "0") {
						_ad = ads.ads.ad
						_reloadAdTime = parseInt(_ad.timeSecBetweenAdservers,10) * 1000
						_adTimeVisible = parseInt(_ad.timeVisible,10) * 1000
						_ad.tag = _tag
						GGG.Console.p("UserAgent: " + _ad.userAgent)
						_drawAd()
					} else {
						_setNextTimeout()
					}
				}
				
			}, function(xhr, e) {
				GGG.Console.p("ADSERVER: ERROR LOADING AD")
				if (GGG.Utils.isDefined(e)) {
					GGG.Console.e(e)
				}
				_setNextTimeout()
			})
		}
	}
	
	// TIMEOUT FUNCTIONS
	function _nextAd() {
		GGG.Console.p("ADSERVER: NEXT: "+_reloadAdTime)
		
		if (_allowed()) {
			_nextAdTimeoutId = setTimeout(_loadAd, _reloadAdTime)
		} else {
			_nextAdTimeoutId = setTimeout(_nextAd, _reloadAdTime)
		}
	}
	
	function _setNextTimeout() {
		clearTimeout(_nextAdTimeoutId)
		if (_running) {
			_nextAd()
		}
	}
	function _setHideTimeout() {
		clearTimeout(_adHideTimeoutId)
		_adHideTimeoutId = setTimeout(_hideAd, _adTimeVisible)
	}
	
	return {
		init: function(userId) {
			// PARAMETERS
			_reloadAdTime = GGG.Config.reloadAdDefault * 1000
			_adTimeVisible = GGG.Config.adTimeVisibleDefault * 1000
			_adTimeoutTime = GGG.Config.adTimeoutTime * 1000
			
			_adServerURL = GGG.Config.adserverURL
			_adServerURL += "?uid=" + userId
			_adServerURL += "&r=" + _renderType
			_adServerURL += "&ads=" + GGG.Config.adTypes
			_adServerURL += "&v=" + GGG.Config.appVersion
			_adServerURL += "&sl=" + (GGG.Utils.supportsLandscape() ? "1" : "0")
			
			// CLOSE BUTTON
			_closeBtn = GGG.Utils.div()
			_closeBtn.setAttribute("id","ggg-ad-close-btn")
			_closeBtn.style.position = "fixed"
			_closeBtn.style.top = "0px"
			_closeBtn.style.right = "0px"
			_closeBtn.style.backgroundImage = "url(" + GGG.Config.closeBtnPath + ")"
			_closeBtn.style.zIndex = "1010"
			
			_closeBtn.addEventListener('click', _clickCloseBtn, false)
			
			GGG.Utils.imgPreload(GGG.Config.closeBtnPath, function() {
				_closeBtn.style.width = this.width + "px"
				_closeBtn.style.height = this.width + "px"
			}, function() {
				GGG.Console.p("ADSERVER: CLOSE BUTTON IMAGE NOT FOUND")
			})
			
			_closeBtn.style.display = "none"
			GGG.Utils.getBody().appendChild(_closeBtn)
			
			// AD DIV
			_adDivPortrait = GGG.Utils.div() 
			_adDivPortrait.setAttribute("id","ggg-ad-portrait")
			
			_adDivLand = GGG.Utils.div()
			_adDivLand.setAttribute("id","ggg-ad-landscape")
			
			_setAdDivStyle(_adDivPortrait)
			_setAdDivStyle(_adDivLand)
			
		},
		setTag: function(tag) {
			GGG.Console.p("ADSERVER: tag: " + tag)
			if (GGG.Utils.isDefined(tag) && _adServerURL) {
				_tag = tag
				if (_firstAdReady() && _allowed()) {
					_firstAd = false
					_loadAd()
				}
			} else {
				GGG.Console.p("ADSERVER not initialized")
			}
		},
		resize: function() {
			if (_ad) {
				if (!_allowed()) {
					_remove()
				} else if (GGG.Utils.isLandscape() && _ad.bannerLand) {
					_adDivPortrait.style.display = "none"
					if (_ad.type != _TYPE_INTERSTITIAL) {
						var newTop = GGG.Utils.getHeight() - _adDivLandHeight
						_adDivLand.style.top = newTop + "px"
					}
					_adDivLand.style.display = "block"
				} else if (GGG.Utils.isPortrait() && _ad.banner) {
					_adDivLand.style.display = "none"
					if (_ad.type != _TYPE_INTERSTITIAL) {
						var newTop = GGG.Utils.getHeight() - _adDivPortraitHeight
						_adDivPortrait.style.top = newTop + "px"
					}
					_adDivPortrait.style.display = "block"
				}
			}
		},
		pause: function() {
			if (_running) {
				_running = false
				clearTimeout(_nextAdTimeoutId)
			}
		},
		resume: function() {
			if (!_running) {
				_running = true
				_setNextTimeout()
			}
		}
	}
}()

GGG.Ajax = function() {
	return {
		GET: "GET",
		POST: "POST",
		send: function(url, method, onSuccess, onError) {
			var xhr = new XMLHttpRequest()
			
			/* To allow cross domain ajax on firefox */
			try {
				netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead")
			} catch (e) {}
			
			
			var urlAux = url
			var params = null
			if (method === this.POST) {
				var splittedUrl = url.split("?")
				urlAux = splittedUrl[0]
				params = splittedUrl[1]
				if (params === "") {
					params = null
				}
			}
			
			xhr.open(method, urlAux, true)
			
			xhr.onreadystatechange = function() {
				if (xhr.readyState === 4) {
					if (xhr.status === 200) {
						if (GGG.Utils.isFunction(onSuccess)) {
							try {
								onSuccess(xhr)
							} catch (e) {
								if (GGG.Utils.isFunction(onError)) {
									onError(xhr, e)
								}
							}
						}
					} else {
						if (GGG.Utils.isFunction(onError)) {
							onError(xhr)
						}
					}
				}
			}
			
			if (method === this.POST) {
				xhr.setRequestHeader("Content-type", "application/x-www-form-urlencoded")
			}
			
			try {
				xhr.send(params)
			} catch (e) {
				if (GGG.Utils.isFunction(onError)) {
					onError(xhr, e)
				}
			}
			
		}
	}
}()

GGG.Animation = function() {
	return {
		create: function(el, speed, onStart, onFinish, accelerationProfile) {
			return new GGG.OperaAnimation(el, speed, onStart, onFinish, accelerationProfile)
		},
		appearBottom: function(el, height, onEnd) {
			//GGG.Console.p("ANIMATION: APPEAR BOTTOM")
			var anim = this.create(el)
			el.style.height = "0px"
			el.style.display = "block"
			anim.setOnFinish(onEnd)
			anim.addAnimation('height', '0px', height + 'px')
				.addAnimation('top', GGG.Utils.getHeight()+'px', el.style.top)
				.run()
		},
		disappearBottom: function(el, onEnd) {
			//GGG.Console.p("ANIMATION: DISAPPEAR BOTTOM")
			var anim = this.create(el)
			anim.setOnFinish(function() {
				el.style.display = "none"
				if (GGG.Utils.isFunction(onEnd)) {
					onEnd()	
				}
			})
			anim.addAnimation('height', el.scrollHeight+'px', '0px')
				.addAnimation('top', el.style.top, GGG.Utils.getHeight()+'px')
				.run()
		}
	}
}()

GGG.Preference = function() {
	return {
		EMPTY: "",
	    save: function(key,value) {
			if (widget && widget.setPreferenceForKey) {
	        	widget.setPreferenceForKey(value,key)
			}
	    },
	    load: function(key) {
			if (widget && widget.preferenceForKey) {
		        var aux = widget.preferenceForKey(key)
		        return aux === undefined ? "" : aux
			} else {
				return ""
			}
	    },
	    remove: function(key) {
	        this.save(key,"")
	    }
	}
}()

GGG.Console = function() {
    var _console = null
	var _consoleOn = false
	
	function _printException(e) {
		var text = ""
		
		try {
			// WIDGET OPERA EMULATOR
			if (parent.emulator) {
				var line = e["opera#sourceloc"]
				var file = ""
				if (e.stacktrace) {
					file = e.stacktrace.split("/widgets/")[1].split(".js")[0]+".js"
				}
				text = "EXCEPTION ("+file+":"+line+"): "
				
			// NOKIA WRT
			} else if (e.lineNumber || e.line) {
				var file = e.fileName || e.sourceURL || e.filename
				if (file) {
					var a = file.split("/")
					file = a[a.length-1]
				}
				var line = e.lineNumber || e.line
				
				text = "EXCEPTION ("+file+":"+line+"): "
				
			// VODAFONE APPS MANAGER
			} else if (e.sourceURL === undefined) {
				text = "EXCEPTION: "				
			} else {
				var file = e.sourceURL.split("js/")[1];
				text = "EXCEPTION ("+file+":"+line+"): "
			}
			
			text += e.message
		} catch (e2) {
			text = e2.message
		}
		
		return text
	}
	
	return {
		ON: true,
		OFF: false,
		init: function(consoleOn) {
			_consoleOn = (consoleOn === this.ON)
			_console = document.createElement('div')
			_console.setAttribute("id","ggg-console")
						
			if (_consoleOn) {
				
				var cs = _console.style
				cs.position = "absolute"
				cs.top = "0px"
				cs.left = "0px"
				cs.zIndex = "100"
				cs.backgroundColor = "black"
				cs.color = "white"
				cs.opacity = "0.7"
				cs.width = "100%"
				cs.fontSize = "12px"
				
				GGG.Utils.getBody().appendChild(_console)
				
				var self = this
				_console.addEventListener('mousedown', function(){
					self.clear()
				}, false)
				
				this.p("CONSOLE INIT DONE")
			}
		},
		e: function(e) {
			this.p(_printException(e))
		},
		p: function() {
			if (_consoleOn) {
				for (var i = 0, l = arguments.length; i < l; i++) {
					_console.appendChild(document.createTextNode(arguments[i]))
					_console.appendChild(document.createElement('hr'))
				}
			}
		},
		clear: function() {
			while (_console.hasChildNodes()) {
				_console.removeChild(_console.firstChild)
			}
		},
		show: function() {
			_console.style.display = "block"
		},
		hide: function() {
			_console.style.display = "none"
		}
	}
}()

GGG.Utils = function() {
	return {
		openURL: function(url) {
			if (widget) {
				widget.openURL(url)
			}
		},
		imgPreload: function(src, onLoad, onError) {
			var image = new Image()
			image.onload = onLoad
			image.onerror = onError
			image.src = src
			return image
		},
		img: function(src) {
			return document.createElement('img')
		},
		div: function() {
			return document.createElement('div')
		},
		removeChilds: function(o) {
			while (o.hasChildNodes()) {
				o.removeChild(o.firstChild)
			}
		},
		isFunction: function(o) {
			return typeof o === "function"
		},
		isDefined: function(o) {
			return typeof o !== "undefined"
		},
		isOVI: function() {
			return this.isDefined(widget.setNavigationEnabled)
		},
		getBody: function() {
			return document.body
		},
		isHomeScreen: function() {
			var r = (this.getWidth() == 312 && this.getHeight() == 82 && this.isOVI()) // N97 terminal
			r = r || (this.getWidth() == 306 && this.getHeight() == 76 && this.isOVI()) // N97 firefox preview
			return r
		},
		isPortrait: function() {
			return !this.isLandscape()
		},
		isDocked: function() {
			return widget.widgetMode == "docked"
		},
		isFloating: function() {
			return widget.widgetMode == "floating"
		},
		getWidth: function() {
			if (this.isOVI()) {
				return window.innerWidth
			} else {
				return screen.availWidth
			}
		},
		getHeight: function() {
			if (this.isOVI()) {
				return window.innerHeight
			} else {
				return screen.availHeight
			}
		},
		getPortraitWidth: function() {
			var w = this.getWidth()
			var h = this.getHeight()
			return w <= h ? w : h
		},
		getPortraitHeight: function() {
			var w = this.getWidth()
			var h = this.getHeight()
			return w <= h ? h : w
		},
		supportsLandscape: function() {
			return GGG.Config.supportsLandscape
		},
		isPortrait: function() {
			return this.getWidth() < this.getHeight() 
		},
		isLandscape: function() {
			return this.getWidth() > this.getHeight()
		},
		getUserAgent: function() {
			if (navigator.userAgent) {
				return navigator.userAgent
			} else {
				return ""
			}
		}
	}
}()


/**
 * Copyright (c) 2006, Opera Software ASA
 * All rights reserved.
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *     * Redistributions of source code must retain the above copyright
 *       notice, this list of conditions and the following disclaimer.
 *     * Redistributions in binary form must reproduce the above copyright
 *       notice, this list of conditions and the following disclaimer in the
 *       documentation and/or other materials provided with the distribution.
 *     * Neither the name of Opera Software ASA nor the
 *       names of its contributors may be used to endorse or promote products
 *       derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY OPERA SOFTWARE ASA AND CONTRIBUTORS ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL OPERA SOFTWARE ASA AND CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
 
/* Version: 0.18 */

GGG.Timer = function() {
	var _time = 15
	var _store = []
	var _run = false
	var _interval = 0
	var _realClock = []
	var _realClockReady = false
	var _onFrame = null
  
  	function _getRealFrame() {
		if (_realClock.length > 30) {
			realClock.shift()
		}
		var length = _realClock.length
		
		_realClock.push(new Date())
		_onFrame(Math.round(1000/((_realClock[length]-_realClock[0])/(length-1))))
  	}
  
  	function _goStep() {
		var noFn = true
		
		for(var i = 0; i < _store.length; i++) { 
			if (_store[i]) {
				_store[i]()
				noFn = false
			}
		}
		if (_onFrame) {
			_getRealFrame()
		}
		if (noFn) {
			_stop()
		}
  	}
  
	function _stop() {
		clearInterval(_interval)
		_run = false
	}
	function _start() {
		_interval = setInterval(_goStep, _time)
		_run = true
	}
	
	return {
		set: function(fn) {
		    var i = 0
		    while(_store[i]) i++
		    _store[i] = fn
			
		    if(!_run) {
				_start()
			}
			
		    return i
		},
		clear: function(index) {
			_store[index] = null
		},
		setOnFrame: function(onFrame) {
			_onFrame = onFrame
		},
		clearOnFrame: function() {
			_onFrame = null
		}
	}
}()


/** 
 * To create a animation object.
 * A animation has a counter which will run from 0 to 100. 
 * All properties which are added with a start and a end value will
 * be adjusted relative to that counter. 
 * @constructor 
 */

GGG.OperaAnimation = function(element, speed, onStart, onFinish, accelerationProfile, onStop) {
	this._properties = []
	this._current = 0
	this._interval = 0
	this._running = false

	this._style = element ? element.style : {}
	this._element = element
	this._speed = speed || this.speed
	
	this._onStart = onStart || null
	this._onFinish = onFinish || null
	this._onStop = onStop || onFinish || null
  	this._accelerationProfile = accelerationProfile || this.constant
	
	if (element) {
		var self = this
		element.addEventListener('DOMNodeRemoved', function(event) {
			if (event.target === self.element) {
				self.remove(false)
			}
		}, false)
	}
}

GGG.OperaAnimation.prototype = {
	REG_TEST_HEX: /^#/,
	REG_IS_COLOR: /^#|^rgb/,
	speed: 6,
	on: true,
	setOnFinish: function(onFinish) {
		this._onFinish = onFinish
	},
	convertToRGB: function(string) {
		var rgb
		
		if (this.REG_TEST_HEX.test(string)) { // #FFFFFF
			var r = 0, g = 0, b = 0
			
			string = string.slice(1)
			
			if (string.length == 3) {
				r = string.slice(0,1)
				r += r
				
				g = string.slice(1,2)
				g += g
				
				b = string.slice(2,3)
				b += b
			} else {
				r = string.slice(0,2)
				g = string.slice(2,4)
				b = string.slice(4,6)
			}
			
			rgb = [parseInt(r,16), parseInt(g,16), parseInt(b,16)]
			
		} else { // rgb(255,255,255)
			var rgbStringSlices = string.slice(string.indexOf('(')+1,string.indexOf(')')).split(',')
			for(var i = 0 ; i < 3; i++) {
				rgb[i] = parseInt(rgbStringSlices[i], 10)
			}
		}
		
		return rgb;
	},
	constant: function(x) {
		return 1
	},
	sine: function(x) {
		return (Math.sin((x)/314)) + 0.2
	},
	accelerate: function(x) {
		return 0.1 + x*x / 10000
	},
	decelerate: function() {
  		return 0.1 + (1 - x*x /10000)
	},
	// strategies
	strategyInt: function(prop, current) {
  		return (prop.from + prop.delta * current/100) + prop.unit
	},
	strategyFloat: function(prop, current) {
		return (prop.from + prop.delta * current/100)
	},
	strategyColor: function(prop, current) {
		var temp = []
		for(var i = 0; i < 3; i++) {
			temp[i] = prop.fromRGB[i] + (Math.round(prop.deltaRGB[i] * current/100))
		}
		return 'rgb('+temp.join(',')+')'
	},
	strategyMoveWindow: function(prop, current) {
		window.moveTo(
			prop.from[0] + (Math.round((prop.to[0] - prop.from[0]) * current/100)),
			prop.from[1] + (Math.round((prop.to[1] - prop.from[1]) * current/100))
		)
	},
	strategyResizeWindow: function(prop, current) {
		window.resizeTo (
			prop.from[0] + (Math.round((prop.to[0] - prop.from[0]) * current/100)),
			prop.from[1] + (Math.round((prop.to[1] - prop.from[1]) * current/100))
		)
	},
	getProperty: function(property) {
		var pointer = null, done = false
		
		for(var i = 0; pointer = this._properties[i] && !done; i++) {
			done = (property == pointer.property)
		}
		
		return pointer;
	},
	checkRun: function() {
		return this._running
	},
	run: function() {
		if (!this.checkRun()) {
			this._running = true
			if (this._onStart) {
				this._onStart()
			}
			if (this.on) {
				var self = this
      			this._interval = GGG.Timer.set(function() {
					self._onStep()
				}) 
			} else {
				this._current = 100
				this._onStep()
			}
		}
	},
	_onStep: function() {
		var finished = ((this._current += this._speed * this._accelerationProfile(this._current)) >= 100)
		if (finished) {
			this._current = 100
			GGG.Timer.clear(this._interval)
		}
		var i=0, prop=null;
		
		var prop = null
		for (var i = 0; prop = this._properties[i]; i++) {
			this._style[prop.property] = prop.strategy(prop, this._current, this)
		}
		
		if (finished) {
			this._current = 0
			this._running = false
			if (this._onFinish) {
				this._onFinish()
			}
		}
	},
	addAnimation: function(property, from, to, customStrategy) {
		var strat = null, unit = '', delta = 0
		var pointer = this.getProperty(property) || 
			(this._properties[this._properties.length] = {})
			
		if(this.REG_IS_COLOR.test(from)) {
			pointer.property = property
			pointer.from = from
			pointer.to = to
			pointer.fromRGB = this.convertToRGB(from)
			pointer.toRGB = this.convertToRGB(to)
			pointer.deltaRGB = [
					(pointer.toRGB[0] - pointer.fromRGB[0]), 
					(pointer.toRGB[1] - pointer.fromRGB[1]), 
					(pointer.toRGB[2] - pointer.fromRGB[2])
				]
			pointer.strategy = this.strategyColor
		} else {
			if (property == 'opacity') {
				strat = this.strategyFloat
				from = parseFloat(from)
				to = parseFloat(to)
			} else if (property.indexOf('window') == 0) {
			
				switch (property) {
					case 'windowMoveTo':
						strat = this.strategyMoveWindow
						from = from.split(',')
						from[0] = parseInt(from[0])
						from[1] = parseInt(from[1])
						to = to.split(',')
						to[0] = parseInt(to[0])
						to[1] = parseInt(to[1])
					break;
					
					case 'windowMoveBy':
						strat = this.strategyMoveWindow
						var by = from.split(',')
						by[0] = parseInt(by[0])
						by[1] = parseInt(by[1])
						
						from = []
						from[0] = window.screenLeft
						from[1] = window.screenTop
						
						to = []
						to[0] = from[0] + by[0]
						to[1] = from[1] + by[1]
					break;
					
					case 'windowResizeTo':
						strat = this.strategyResizeWindow
						
						var to = from.split(',')
						to[0]=parseInt(to[0])
						to[1]=parseInt(to[1])
						
						from = []
						from[0] = window.innerWidth
						from[1] = window.innerHeight
					break;
					
					case 'windowResizeBy':
						strat = this.strategyResizeWindow
						
						var by = from.split(',')
						by[0]=parseInt(by[0])
						by[1]=parseInt(by[1])
						
						from=[]
						from[0]=window.innerWidth
						from[1]=window.innerHeight
						
						to=[]
						to[0] = from[0] + by[0]
						to[1] = from[1] + by[1]
					break;
				}
			} else if (strat = customStrategy) {
				unit = from.replace(/-?\d*/g,'')
				from = parseFloat(from)
				to = parseFloat(to)
			} else {
				strat = this.strategyInt
				unit = from.replace(/-?\d*/g,'')
				from = parseInt(from)
				to = parseInt(to)
			}
		
			pointer.property = property
			pointer.unit = unit
			pointer.from = from
			pointer.to = to
			pointer.delta = to-from // TODO clan this up
			pointer.strategy = strat
		}
		
		return this
	},
	removeAnimation: function(property) {
		for (var i = 0, pointer; pointer = this._properties[i]; i++) {
			if (property == pointer.property) {
			      this._properties.splice(i, 1);
			      return true;
			}
		}
		return false
	},
	stop: function() {
		if(this.checkRun()) {
			GGG.Timer.clear(this._interval)
			this._current = 0
			this._running = false
			if(this._onStop) {
				this._onStop()
			}
		}
	},
	pauseAnimation: function() {
		if(this.checkRun()) {
			GGG.Timer.clear(this._interval)
			this._running = false
		}
	},
	continueAnimation: function() {
		if(!this.checkRun() && this._current) { 
			this.running = true
			var self = this
			this._interval = GGG.Timer.set(function() {
				self.onStep()
			}) 
		}
	},
	remove: function(removeElement) {
		if (this.checkRun()) {
			GGG.Timer.clear(this._interval)
		}
		if (removeElement && this._element && this._element.parentNode) {
			this._element.parentNode.removeChild(this.element)
		}
		delete this._element
		delete this._style
		delete this._onStart
		delete this._onFinish
		delete this._onStop
		delete this._accelerationProfile
	}
}