var Pagging = function(el, onDraw) {
	var _el = el
	var _text = el.select(".pagging-text")[0]
	var _nextBtn = el.select(".pagging-next-btn")[0]
	var _backBtn = el.select(".pagging-back-btn")[0]
	
	var _onDraw = onDraw
	var _numElements = 0
	var _pageSize = 0
	var _numPages = 0
	var _curPage = 0
	
	_nextBtn.observe('click', function() {
		_next()
	})
	_backBtn.observe('click', function() {
		_back()
	})
	
	
	function _update() {
		_text.update((_curPage + 1) + "/" + _numPages)
		var iStart = _curPage * _pageSize
		var iEnd = iStart + _pageSize
		if (iEnd > _numElements) {
			iEnd = _numElements
		}
		_onDraw(iStart, iEnd)
		
		if (_curPage == 0) {
			_backBtn.style.visibility = "hidden"
		} else {
			_backBtn.style.visibility = "visible"
		}
		if (_curPage < _numPages - 1) {
			_nextBtn.style.visibility = "visible"
		} else {
			_nextBtn.style.visibility = "hidden"
		}
	}
	function _next() {
		if (_curPage < _numPages - 1) {
			_curPage++
			_update()
		}
	}
	function _back() {
		if (_curPage > 0) {
			_curPage--
			_update()
		}
	}
	
	return {
		getNumPages: function() {
			return _numPages
		},
		setParams: function(numElements, pageSize) {
			_numElements = numElements
			_pageSize = pageSize
			_numPages = Math.ceil(numElements / pageSize)
			_curPage = 0
			_update()
		},
		hide: function() {
			_el.hide()
		},
		show: function() {
			_el.show()
		}
	}
}
