
var Rotator = function(el, frames, speed, cycle) {	
	var _BACKGROUND_MODE = 0
	var _IMG_MODE = 1
    var _el = el
    var _frames = frames
    var _speed = speed || 100
    var _current = 0
    var _running = false
	var _mode = (el.tagName == "IMG") ? _IMG_MODE : _BACKGROUND_MODE
	var _cycle = typeof cycle == "undefined" ? Rotator.CYCLE : cycle
	
    var _onStop = null
    var _intervalId = null
    var _timeoutId = null
	
    function _setFrame() {
        var url = _frames[_current]
		switch (_mode) {
			case _BACKGROUND_MODE:
        		_el.style.backgroundImage = "url("+url+")"
				break;
			case _IMG_MODE:
				_el.src = url
				break;
		}
    }
	
    function _setNextFrame() {
        _current = (_current + 1) % _frames.length
    	_setFrame()
		
		if (_cycle == Rotator.NOT_CYCLE && _current == _frames.length - 1) {
			_stop()
		}
    }
	
	function _stop() {
        _running = false
        if (_intervalId) {
			clearInterval(_intervalId)
			_intervalId = null
		}
		if (_timeoutId) {
			clearTimeout(_timeoutId)
			_timeoutId = null
		}
        if (_onStop) {
            _onStop()
			_onStop = null
        }
	}
	
	_setFrame()
		
	return {
	    start: function(time,onStop) {
	        this.stop()
	        _running = true	        
	        
			var self = this
	        if (time !== undefined) {
	            _timeoutId = setTimeout(function() {
	                self.stop()
	            },time)
	        }			
	        if (onStop !== undefined) {
	            _onStop = onStop
	        }
			
	        _intervalId = setInterval(function() {
	            _setNextFrame()
	        },_speed)
	    },
		restart: function() {
			_current = 0
			_setFrame()
			this.start()
		},
	    stop: function() {
			_stop()
	    },
	    isRunning: function() {
	        return _running
	    }
	}	
}

Rotator.CYCLE = true
Rotator.NOT_CYCLE = false