var Terminal = function() {
	var _terminal = null
	
	var _QVGA = "qvga"
	var _HVGA = "hvga"
	var _NHD = "nhd"
	var _WVGA = "wvga"
	
	var _N95_V360 = {
		name: "N95",
		screen: _QVGA,
		landscape: true,
		width: 240,
		height: 266,
		dockedMaxSize: 90
	}
	var _N95_OVI = {
		name: "N95",
		screen: _QVGA,
		landscape: true,
		width: 240,
		height: 320
	}	
	var _N97_V360 = {
		name: "N97",
		screen: _NHD,
		landscape: true,
		width: 360,
		height: 532,
		dockedMaxSize: 120
	}
	var _N97_OVI = {
		name: "N97",
		screen: _NHD,
		landscape: true,
		width: 360,
		height: 579
	}
	var _M1_V360 = {
		name: "M1",
		screen: _QVGA,
		landscape: false,
		width: 240,
		height: 330,
		floatingSize: 120
	}
	var _H1_V360 = {
		name: "H1",
		screen: _WVGA,
		landscape: false,
		width: 480,
		height: 684,
		floatingSize: 230
	}
	
	// V360
	function _setV360(width,height) {
		if (View.isDocked()) {
			if (width <= _N95_V360.dockedMaxSize) {
				_terminal = _N95_V360
			} else {
				_terminal = _N97_V360
			}
		} else if (View.isFloating()) {
			if (width <= _M1_V360.floatingSize) {
				_terminal = _M1_V360
			} else {
				_terminal = _H1_V360
			}
		} else if (View.isLandscape()) {
			if (width <= _N95_V360.height) {
				_terminal = _N95_V360
			} else {
				_terminal = _N97_V360
			}
		} else { // Portrait
			if (width <= _N95_V360.width) {
				if (height <= _N95_v360.height) {
					_terminal = _N95_V360
				} else {
					_terminal = _M1_V360
				}
			} else if (width <= _N97_V360.width) {
				_terminal = _N97_V360
			} else {
				_terminal = _H1_V360
			}
		}
	}
	
	// OVI
	function _setOVI(width,height) {
		if (View.isHomeScreen()) {
			_terminal = _N97_OVI
		} else if (View.isLandscape()) {
			if (width <= _N95_OVI.height) {
				_terminal = _N95_OVI
			} else {
				_terminal = _N97_OVI
			}
		} else { // Portrait
			if (width <= _N95_OVI.width) {
				_terminal = _N95_OVI
			} else {
				_terminal = _N97_OVI
			}
		}
	}
	
	return {
		QVGA: _QVGA,
		HVGA: _HVGA,
		NHD: _NHD,
		WVGA: _WVGA,
		init: function(w, h) {
			if (this.isV360()) {
				_setV360(w,h)
			} else {
				_setOVI(w,h)
			}
			Console.p(Terminal.toString())
		},
		toString: function() {
			var r = _terminal.name
			r += ": " + _terminal.width + "x" + _terminal.height
			r += " " + _terminal.screen
			if (this.hasLandscape()) {
				r += " +land"
			}
			return r
		},
		getWidth: function() {
			return _terminal.width
		},
		getHeight: function() {
			return _terminal.height
		},
		getScreen: function() {
			return _terminal.screen
		},
		hasLandscape: function() {
			return _terminal.landscape
		},
		isV360: function() {
			return !this.isOVI()
		},
		isOVI: function() {
			return typeof widget.setNavigationEnabled !== "undefined"
		}
	}
}()
