var Timer = function(cont) {
	
    var _cont = cont
    var _paused = false
    var _running = false
    var _seconds = 0
    var _triggers = []
	var _interval = null
	
	return {
	    start: function() {
	        this.pause()
	        _running = true
	        _seconds = 0
	        this.printTime()
	        this.resume()
	    },
	    step: function() {
	        //Console.post("Timer STEP: " + _seconds)
	        if (_running) {
	            _seconds++
	            this.printTime()
	            if (_triggers[_seconds]) {
					_triggers[_seconds]()
				}
	        }
	    },
	    pause: function() {
	        _paused = true
	        if (_interval) {
	            clearInterval(_interval)
	        }
	    },
	    resume: function() {
	        if (_running && _paused) {
	            _paused = false
	            var self = this
	            _interval = setInterval(function() {
	                self.step()
	            },1000);
	        }
	    },
	    stop: function() {
	        _running = false
	        clearInterval(_interval)
	        this.clearTriggers()
	    },
	    printTime: function() {
	        if (_cont) {
				_cont.update(this.getTime())
			}
	    },
	    getTime: function() {
	        var m = Math.floor(_seconds/60)
	        var s = _seconds%60
			
	        if (m<10) {
				m = "0"+m
			}
	        if (s<10) {
				s = "0"+s
			}
			
	        return m+":"+s
	    },
		getSeconds: function() {
			return _seconds
		},
	    setSeconds: function(s) {
	        _seconds = s
	        this.printTime()
	    },
	    setTrigger: function(s,f) {
	        _triggers[s] = f
	    },
	    clearTriggers: function() {
	        _triggers = []
	    }
	}
}

function Timer(cont) {
}

Timer.prototype = {
}