
Utils = {
	printFields: function(o) {
		var text = ""
		for (var field in o) {
			text += field+", "
		}
		return text
	},
	getComputedStyle: function(el,prop) {
		return window.getComputedStyle(el,null).getPropertyValue(prop)
	},	
	getDPI: function() {
		var d = Utils.Paint.div('div')
		var s = d.style
		s.position = "absolute"
		s.top = "0px"
		s.left = "0px"
		s.visibility = "hidden"
		s.width = "1in"
		
		View.getBody().appendChild(d)
		
		var dpi = Utils.getComputedStyle(d,'width')
		
		View.getBody().removeChild(d)
		
		return parseInt(dpi)
	}
}

Utils.Ajax = function(url,m,cb,p) {
	
	var method = m || "get"
	var parameters = p || {}
	var callbacks = cb || {}
	
	/* To allow cross domain ajax on firefox */
	try {
		netscape.security.PrivilegeManager.enablePrivilege("UniversalBrowserRead")
	} catch (e) {}
	
	Console.p(url)
	var xhr = new Ajax.Request(url, {
        'method': method,
		'parameters': parameters,
        onSuccess: function(transport) {
			if (callbacks.success) callbacks.success(transport.responseText)
        },
        onFailure: function(transport) {
			if (callbacks.fail) callbacks.fail(transport.status)
			else if (callbacks.error) callbacks.error("fail",transport.status)
        },
        onException: function(transport,exception) {
			if (callbacks.exception) callbacks.exception(exception)
			else if (callbacks.error) callbacks.error("exception",exception)
        }
    })
	return xhr
}

Utils.DeviceApps = {
    BROWSER: "com.samsung.internet",
    SMS: "com.samsung.message",
    FILE_MANAGER: "com.samsung.myfiles",
    CALENDAR: "com.samsung.calendar",
    CAMERA: "com.samsung.camera",
    ALARM: "com.samsung.alarm",
    SETTINGS: "com.samsung.setting",
    MUSIC_PLAYER: "com.samsung.musicplayer",
    VIDEO_WEB_PLAYER: "com.samsung.webplayer",
    CARD_SCANNER: "com.samsung.cardscanner",
    WIFI: "com.samsung.wifi",
    PHOTO_GALLERY: "com.samsung.gallery",
    MAIL: "com.samsung.email",
    VOICE_RECORDER: "com.samsung.voicerecorder",
    CALCULATOR: "com.samsung.calculator",
    UNITS: "com.samsung.units",
    WORLD_CLOCK: "com.samsung.worldclock",
    NOTES: "com.samsung.notes",
    FILE_VIEW: "com.samsung.fileview",
    STOPWATCH: "com.samsung.stopwatch",
    RSS: "com.samsung.rss",
    MAPS: "com.samsung.maps",
    RADIO: "com.samsung.radio",
    SUPERSTORE: "com.samsung.superstore",
	getApps: function() {
		return Widget.Device.getAvailableApplications()
	},
	openVideo: function(url) {
		this.launch(this.VIDEO_WEB_PLAYER,url)
	},
	launch: function(app,param) {
		Console.p("DeviceApp ("+app+") "+param)
		if (!View.isEmulator()) {
			Widget.Device.launchApplication(app, param)
		}
	}
}

Utils.Paint = {	
    div: function(cssClass,id) {
        var o = {}
        if (cssClass) o["class"] = cssClass
        if (id) o["id"] = id
        return new Element('div',o)
    },
    img: function(cssClass,src,onErrorSrc) {
        var o = {}
        if (cssClass) o["class"] = cssClass
        if (src) o["src"] = src
		if (onErrorSrc) o["onerror"] = "src=\""+onErrorSrc+"\""
        return new Element('img',o)
    },
	imgDelOnError: function(cssClass,src) {
		var img = new Element('img',{'class':cssClass})
		img.onerror = function() {
			if (this.parentNode) this.remove()
		}
		img.src = src
		return img
	},
    bgImg: function(cssClass,src) {
        var o = {}
        if (cssClass) o["class"] = cssClass
        var e = new Element('div',o)
        e.style.backgroundImage = "url("+src+")"
        return e
    },
	link: function(cssClass,href) {
		var o = {}
		if (cssClass) o["class"] = cssClass
		if (href) o["href"] = href
		var e = new Element('a',o)
		return e
	},
    box: function(content,id,cssClass) {
		var o = {}
		if (cssClass) o["class"] = cssClass
		else o["class"] = "box"
		if (id) o["id"] = id
		var box = new Element('div',o)
		
		var r1 = this.div("row")
		r1.insert(this.div("ul"))
		r1.insert(this.div("u"))
		r1.insert(this.div("ur"))
		box.insert(r1)
		
		var r2 = this.div("row")
		r2.insert(this.div("l"))
		r2.insert(this.div("c").insert(content))
		r2.insert(this.div("r"))
		box.insert(r2)
		
		var r3 = this.div("row")
		r3.insert(this.div("bl"))
		r3.insert(this.div("b"))
		r3.insert(this.div("br"))
		box.insert(r3)
		
		return box;
    }
}

Utils.Require = function() {
	var _requiredFiles = {}
	var _scriptsDirectory = "js/%s.js"	
	
	function _requireUrl(url) {
		var tag = document.createElement('script')
		tag.setAttribute("language","javascript")
		tag.setAttribute("charset","utf-8")
		tag.setAttribute("src",url)
		document.getElementsByTagName('head')[0].appendChild(tag)
	}
	
	return {
		GGG_TIMER: "ggg/timer",
		GGG_SCROLL: "ggg/scroll",
		GGG_ROTATOR: "ggg/rotator",
		
		lib: function(apiCode) {
			if (_requiredFiles[apiCode] === undefined) {
				var url = _scriptsDirectory.replace("%s",apiCode)
				_requiredFiles[apiCode] = true
				_requireUrl(url)
			}
		},
		section: function(name) {
			var url = _scriptsDirectory.replace("%s",name)
			_requireUrl(url)
		}
	}
}()

Utils.Inheritance = {
    clone: function(o) {
        function F() {}
        F.prototype = o
        return new F
    }
}

Utils.Images = function () {
	return {
		preload:  function() {
			for (var i = 0; i < arguments.length; i++) {
				if (Object.isArray(arguments[i])) {
					var a = arguments[i]
					for (var j = 0; j < a.length; j++) {
						this.preload(a[j])
					}
				} else {
					var image = new Image()
					image.src = arguments[i]
				}
			}
		},
		dimensions: function(url,onLoad) {			
			var imagePreview = new Image()
			imagePreview.onload = function() {
				onLoad(this.width,this.height)
			}
			imagePreview.onerror = function() {
				onLoad(0,0)
			}
			imagePreview.src = url			
		}
	}
}()

Utils.Math = {
    random: function(n,m) {
		var r
		if (m === undefined) {
			r = Math.floor(Math.random()*n)
		} else {
			var dif = m-n
			r = Math.floor(Math.random()*dif)
			r += n
		}
		return r
    }
}

Utils.Set = {
    build: function() {
		var res = {}
		for (var i = 0; i < arguments.length; i++) {
			if (Object.isArray(arguments[i])) {
				var a = arguments[i]
				for (var j = 0; j < a.length; j++) {
					res[a[j]] = true
				}
			} else {
				res[arguments[i]] = true
			}
		}
		return res
    }
}

// events
Element.prototype.fireClick = function() {
	var click = document.createEvent("MouseEvents")
	click.initMouseEvent("click", true, true, window, 0, 0, 0, 0, 0, false, false, false, false, 0, null)
	this.dispatchEvent(click)
}

// effects
Element.prototype.fadeIn = function(speed,onEnd) {
	var anim = this.createAnimation()
	if (speed) anim.speed = speed
    this.style.opacity = "0"
    this.show()
	anim.onfinish = onEnd
    anim.addAnimation('opacity', '0', '1').run()
}
Element.prototype.fadeOut = function(speed,onEnd) {
	var anim = this.createAnimation()
	if (speed) anim.speed = speed
    this.style.opacity = "1"
	var self = this
    anim.onfinish = function() {
        self.hide()
		if (onEnd) onEnd()
    }
    anim.addAnimation('opacity', '1', '0').run()
}
Element.prototype.appearBottom = function(onEnd) {
	var anim = this.createAnimation()
	this.style.height = "0px"
	this.show()
	anim.onfinish = onEnd
	anim.addAnimation('height', '0px', this.scrollHeight+'px')
		.addAnimation('top', View.getHeight()+'px', this.style.top)
		.run()
}
Element.prototype.disappearBottom = function(onEnd) {
	var anim = this.createAnimation()
	var self = this
	anim.onfinish = function() {
        self.hide()
		if (onEnd) onEnd()
	}
	anim.addAnimation('height', this.scrollHeight+'px', '0px')
		.addAnimation('top', this.style.top, View.getHeight()+'px')
		.run()
}


	function $right(str, n){
		if (n <= 0)
		   return "";
		else if (n > String(str).length)
		   return str;
		else {
		   var iLen = String(str).length;
		   return String(str).substring(iLen, iLen - n);
		}
	}