
window.onload = function() {
	
	// SINGLETONS INITIALIZATIONS

	try {
		Console.init()
		//Console.p("Console.init() DONE")
	} catch(e) {
		Console.eBody(e)
	}
	
	try {
		Config.init()
		Console.p("Config.init() DONE")
		
		Localization.init()
		//Console.p("Local.init() DONE")
		
		View.init()
		//Console.p("View.init() DONE")
		
		Controller.init()
		//Console.p("Controller.init() DONE")
		
		// RESIZE EVENT
		if (Terminal.isV360()) {
			if (View.isEmulator()) {
				window.addEventListener('resize', function() {
					Controller.onResize()
				}, false)
			} else {
				widget.addEventListener('resolution', function() {
					Controller.onResize()
				}, false)
			}
		} else {
			window.addEventListener('resize', function() {
				Controller.onResize()
			}, false)
		}
		
		// KEYS EVENTS
		if (Config.is4ways) {
			if (Terminal.isOVI()) {
				widget.setNavigationEnabled(false)
			}
			document.addEventListener('keyup', Controller.keyUp, false)
			document.addEventListener('keydown', Controller.keyDown, false)
			document.addEventListener('keypress', Controller.keyPress, false)
		}
		
		if (typeof Application != undefined && Application.onStart) {
			Application.onStart()
		}
		
	} catch(e) {
		Console.e(e)
	}
}